root = {
	Create = function(self, prefix)

		local mainFrame = CreateFrame("Frame", "LH_Tracker", UIParent, "BasicFrameTemplate")

		mainFrame.debug = false
		if mainFrame.debug then
			ChatFrame1:AddMessage("RPMLoot_Debuging")
		end

		mainFrame.enabled = true
		mainFrame.rolls = mainFrame.rolls or { }
		mainFrame.rollType = mainFrame.rollType or { }
		mainFrame.prefix = prefix;
		mainFrame.size = 0
		mainFrame.rolling = nil
		mainFrame.reroll = false;
		mainFrame.rollTime = 30
		-- change  # to a different # to give more or less time to roll
		mainFrame.winners = { }
		mainFrame.candidates = { }
		mainFrame.itemQueue = { }
		mainFrame.masterLootQueue = { }
		mainFrame.awardLoot = false
		mainFrame.chatType = "GUILD"
		mainFrame.roolFrame = roll:Create(mainFrame.prefix, mainFrame)
		mainFrame.group = IsInGroup()


		mainFrame:RegisterEvent("LOOT_OPENED")
		mainFrame:RegisterEvent("LOOT_CLOSED")
		mainFrame:RegisterEvent("LOOT_SLOT_CHANGED")
		mainFrame:RegisterEvent("LOOT_SLOT_CLEARED")
		mainFrame:RegisterEvent("CHAT_MSG_ADDON")
		mainFrame:RegisterEvent("CHAT_MSG_SYSTEM")
		mainFrame:RegisterEvent("CHAT_MSG_LOOT")
		mainFrame:RegisterEvent("CHAT_MSG_WHISPER")
		mainFrame:RegisterEvent("PARTY_LEADER_CHANGED")
		mainFrame:RegisterEvent("PARTY_LOOT_METHOD_CHANGED")
		mainFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
		mainFrame:RegisterEvent("GROUP_ROSTER_UPDATE")
		mainFrame:RegisterEvent("CHAT_MSG_RAID_WARNING")
		mainFrame:RegisterEvent("CHAT_MSG_PARTY_LEADER")
		mainFrame:RegisterEvent("ADDON_LOADED")

		
		
		mainFrame.nextBTN = CreateFrame("Button", "root_btn_next", mainFrame, "UIPanelButtonTemplate")
		mainFrame.nextBTN:SetPoint("TOPLEFT", LootFrame, "BOTTOMLEFT", 0, 1)
		mainFrame.nextBTN:SetPoint("TOPRIGHT", LootFrame, "BOTTOMRIGHT", 0, 1)
		mainFrame.nextBTN:SetWidth(100)
		mainFrame.nextBTN:SetHeight(22)
		mainFrame.nextBTN:SetText("Next Item")
		mainFrame.nextBTN:SetScript("OnClick",
		function(self, button, down)
			mainFrame.size = mainFrame.rolling + 1
		end
		)
		mainFrame.nextBTN:Hide()
		
		mainFrame.automateBTN = CreateFrame("Button", "root_btn_automate", mainFrame, "UIPanelButtonTemplate")
		mainFrame.automateBTN:SetPoint("TOPLEFT", LootFrame, "BOTTOMLEFT", 0, 1)
		mainFrame.automateBTN:SetPoint("TOPRIGHT", LootFrame, "BOTTOMRIGHT", 0, 1)
		mainFrame.automateBTN:SetWidth(100)
		mainFrame.automateBTN:SetHeight(22)
		mainFrame.automateBTN:SetText("Automate")
		mainFrame.automateBTN:SetScript("OnClick",
		function(self, button, down)

			for i, j in pairs(mainFrame.masterLootQueue) do
				table.insert(mainFrame.itemQueue, j)
				-- { link, lootNum }
				SendChatMessage(j[2] .. ": " .. j[1], mainFrame.chatType)
			end
			table.sort(mainFrame.itemQueue, function(a, b) return select(4, GetItemInfo(a[1])) < select(4, GetItemInfo(b[1])) end);

			mainFrame.automateBTN:Hide()
		end
		)

		





		mainFrame.automateBTN:Hide()


		mainFrame.getCount = function(ta)
			local count = 0;
			for k in pairs(ta) do
				count = count + 1;
			end
			return count;
		end
		mainFrame.findWiner = function(ta, rollType)
			local k
			local v = 0
			local typ
			local typeOfWinner = "Reg"
			local m_rolls = { }
			local o_rolls = { }
			local u_rolls = { }
			local t_rolls = { }
			for name, tp in pairs(rollType) do
				if tp == "M" then
					m_rolls[name] = ta[name]
				elseif tp == "O" then
					o_rolls[name] = ta[name]
				elseif tp == "U" then
					u_rolls[name] = ta[name]
				elseif tp == "T" then
					t_rolls[name] = ta[name]
				end
			end
			if mainFrame.getCount(m_rolls) > 0 then
				ta = m_rolls
				typeOfWinner = "Main"
			elseif mainFrame.getCount(o_rolls) > 0 then
				ta = o_rolls
				typeOfWinner = "Off Spec"
			elseif mainFrame.getCount(u_rolls) > 0 then
				ta = u_rolls
				typeOfWinner = "Upgrade"
			elseif mainFrame.getCount(t_rolls) > 0 then
				ta = t_rolls
				typeOfWinner = "T-mog"
			end

			local winers = { }
			for key, val in pairs(ta) do
				-- key = name , val = roll#
				if tonumber(val) > tonumber(v) then
					k = key
					v = val
				end
			end
			for key, val in pairs(ta) do
				if tostring(val) == tostring(v) then
					table.insert(winers, key)
				end
			end
			return winers, v, typeOfWinner
		end

		mainFrame.everyoneRolledCheck = function()
			if mainFrame.rolling == nil then
				mainFrame.rolling = GetNumGroupMembers()
			end
			if mainFrame.size > mainFrame.rolling then

				local winners, rolled, typeOfWinner = mainFrame.findWiner(mainFrame.rolls, mainFrame.rollType)

				mainFrame.rolling = mainFrame.getCount(winners)
				if mainFrame.rolling == 1 then

					-- anounce the winner prep for next roll --------------------------
					if mainFrame.lootMethod == "master" and mainFrame.masterLooter then
						if tonumber(mainFrame.owner) ~= nil and mainFrame.awardLoot then
							GiveMasterLoot(mainFrame.owner, tonumber(mainFrame.candidates[winners[1]]))
						end
						SendChatMessage("<LH> " .. winners[1] .. " won " .. mainFrame.itemLink .. " with a " .. rolled .. " (" .. typeOfWinner .. ")", mainFrame.chatType)
						SendAddonMessage(mainFrame.prefix, "<LH> " .. winners[1] .. " won " .. mainFrame.itemLink .. " from " .. mainFrame.player .. " with a " .. rolled, mainFrame.chatType)

					else
						SendAddonMessage(mainFrame.prefix, "<LH> " .. winners[1] .. " won " .. mainFrame.itemLink .. " from " .. mainFrame.owner .. " with a " .. rolled, mainFrame.chatType)
						SendChatMessage("<LH> " .. winners[1] .. " won " .. mainFrame.itemLink .. " from " .. mainFrame.owner .. " with a " .. rolled .. " (" .. typeOfWinner .. ")", mainFrame.chatType)
					end
					mainFrame.rolling = GetNumGroupMembers()
					mainFrame.reroll = false;
					mainFrame.size = 0;
					mainFrame.rolls = { }
					mainFrame.rollType = { }
					mainFrame.winners = { }
				elseif mainFrame.rolling > 1 then
					-- ReRoll   2 or more winners -----------------------------------------
					mainFrame.reroll = true
					mainFrame.winners = winners
					mainFrame.rolling = mainFrame.getCount(winners)
					mainFrame.size = 1;
					mainFrame.rolls = { }
					SendChatMessage("<LH> Following People Rolled " .. rolled .. " (" .. typeOfWinner .. ")   and will reroll to determine the winner", mainFrame.chatType)
					local winerString = ""
					for key, val in pairs(mainFrame.winners) do
						winerString = val .. " " .. winerString
					end
					SendChatMessage(winerString, mainFrame.chatType)
					for key, val in pairs(mainFrame.winners) do
						SendAddonMessage(mainFrame.prefix, "<LH>ReRoll", "WHISPER", val)
					end


				elseif mainFrame.rolling == 0 then
					-- No one Rolled ----
					if tonumber(mainFrame.owner) ~= nil then
						SendAddonMessage(mainFrame.prefix, "<LH> Nobody rolled for " .. mainFrame.itemLink .. " from " .. mainFrame.player, mainFrame.chatType)

						SendChatMessage("<LH> Nobody rolled for item    " .. mainFrame.owner .. ") " .. mainFrame.itemLink, mainFrame.chatType)
					else
						SendAddonMessage(mainFrame.prefix, "<LH> Nobody rolled for " .. mainFrame.itemLink .. " from " .. mainFrame.owner, mainFrame.chatType)

						SendChatMessage("<LH> Nobody rolled for " .. mainFrame.itemLink .. " from " .. mainFrame.owner, mainFrame.chatType)
					end
					mainFrame.size = 0;
					mainFrame.rolls = { }
					mainFrame.rollType = { }
					mainFrame.winners = { }
				end

			end
		end
		--------------------------------------------------



		mainFrame:SetScript("OnUpdate",
		function(self, e, ...)
			if self.enabled then
				if (self.leader and self.lootMethod ~= "master") or(self.lootMethod == "master" and self.masterLooter) then
					if self.size > 0 then
						self.timePased = self.timePased or 0
						self.timePased = self.timePased + e
						self.nextBTN:SetText("Next Item ("..string.format("%d",math.ceil(self.rollTime-self.timePased)) ..")")
						if (self.timePased > self.rollTime) or(self.size > self.rolling) then
							self.size = self.rolling + 1
							-- indicated that everyone hass rolled
							self.timePased = 0
							-- reset timer for the next roll
							self.everyoneRolledCheck()
							self.nextBTN:Hide()
						end
					elseif self.size == 0 and getn(self.itemQueue) > 0 then

						local itemQue = table.remove(self.itemQueue)

						self.candidates = { }
						self.rolling = 0
						self.timePased = 0
						self.owner = itemQue[2]
						self.itemLink = itemQue[1]
						self.size = 1
						-- when self.size is set to  1   begin listening for rolls

						if self.lootMethod == "master" and tonumber(itemQue[2]) ~= nil then
							for candNum = 1, GetNumGroupMembers() do
								local cand = GetMasterLootCandidate(itemQue[2], candNum)
								if cand ~= nil then
									self.candidates[cand] = candNum
									self.rolling = self.rolling + 1
									-- SendAddonMessage(self.prefix, "<LH> Roll for " .. itemQue[1] .. " from " .. itemQue[2],"WHISPER",cand);
								end
							end
							SendAddonMessage(self.prefix, "<LH> Roll for " .. itemQue[1] .. " from " .. itemQue[2], self.chatType);
							SendChatMessage("<LH> Roll for item " .. itemQue[2] .. ") " .. itemQue[1], self.chatType)
							self.nextBTN:Show()
						else
							self.rolling = GetNumGroupMembers() -1
							SendAddonMessage(self.prefix, "<LH> Roll for " .. itemQue[1] .. " from " .. itemQue[2], self.chatType);
							SendChatMessage("<LH> Roll for " .. itemQue[1] .. " from " .. itemQue[2], self.chatType)
						end
						if self.debug then
							self.rolling = 1
							self.candidates[GetUnitName("player")] = 1
						end

					end
				end
			end
		end
		)



		mainFrame:SetScript("OnEvent",
		function(self, event, prefex, message, Type, name_ralm, name)
			if event == "ADDON_LOADED" and prefex == "RPMLoot" then
				if RPMLoot_Var ~= nil then
					if RPMLoot_Var["enabled"] ~= nil then
						mainFrame.enabled = RPMLoot_Var["enabled"]
					else
						RPMLoot_Var["enabled"] = true
						mainFrame.enabled = true
					end
				else
					RPMLoot_Var = { }
					RPMLoot_Var["enabled"] = true
					mainFrame.enabled = true
				end
				if mainFrame.enabled then
					ChatFrame1:AddMessage(prefix .. ": Enabled")
				else
					ChatFrame1:AddMessage(prefix .. ": Disabled")
				end
			end
			if self.enabled then
				if (event == "GROUP_ROSTER_UPDATE" or event == "PARTY_LEADER_CHANGED" or event == "PARTY_LOOT_METHOD_CHANGED" or event == "PLAYER_ENTERING_WORLD") then
					self.group = IsInGroup()
					if self.group then
						self.chatType = "PARTY"
						if IsInRaid() then
							self.chatType = "RAID"
						end
						self.leader = UnitIsGroupLeader("player")
						self.lootMethod = GetLootMethod()
						self.lootThreshold = GetLootThreshold()
						self.masterLooter = IsMasterLooter("player")
						self.player = GetUnitName("player", false)

					end
					if self.debug then
						self.group = true
						self.chatType = "GUILD"
						self.leader = true
						self.masterLooter = true
						self.player = "Looter"
						self.lootMethod = "master"
						self.lootThreshold = 0
					end
					return
				elseif event == "CHAT_MSG_RAID_WARNING" or event == "CHAT_MSG_PARTY_LEADER" then
					-- ================================== PLH ========================================--
					i, j = string.find(prefex, "<PLH>%s* Roll%s* for%s* |%x+|Hitem:.-|h.-|h|r%s*%(%d*%s*.*%)%s*from%s*.+")
					if i ~= nil and j ~= nil then
						local owner = string.match(prefex, "<PLH>%s* Roll%s* for%s* |%x+|Hitem:.-|h.-|h|r%s*%(%d*%s*.*%)%s*from%s*(.+)")
						if owner ~= self.player then
							local itemLink = string.match(prefex, "|%x+|Hitem:.-|h.-|h|r")
							self.itemLink = itemLink
							self.owner = owner
							self.roolFrame:ShowFrame(owner, itemLink)
						end
					end
					i, j = string.find(prefex, "<PLH>%s* .+%s* won%s* |%x+|Hitem:.-|h.-|h|r%s* from%s* .+%s* with%s* a%s* %d*")
					if i ~= nil and j ~= nil then
						if self.roolFrame ~= nil then
							self.roolFrame:HideFrame()
						end
						local itemLink = string.match(prefex, "|%x+|Hitem:.-|h.-|h|r")
						if itemLink ~= nil then
							local winer = string.match(prefex, "<PLH>%s* (.+)%s* won%s* |%x+|Hitem:.-|h.-|h|r%s* from%s* .+%s* with%s* a%s* %d*")
							local owner = string.match(prefex, "<PLH>%s* .+%s* won%s* |%x+|Hitem:.-|h.-|h|r%s* from%s* (.+)%s* with%s* a%s* %d*")
							local rolled = string.match(prefex, "<PLH>%s* .+%s* won%s* |%x+|Hitem:.-|h.-|h|r%s* from%s* .+%s* with%s* a%s* (%d*)")
							if winer == self.player or owner == self.player then
								self:winTablesShow(winer, itemLink, owner, rolled)
								return false;
							end
						end
					end
					i, j = string.find(prefex, "<PLH>%s* Nobody%s* rolled%s* for%s* |%x+|Hitem:.-|h.-|h|r%s* from%s* .+")
					if i ~= nil and i ~= nil then
						if self.roolFrame ~= nil then
							self.roolFrame:HideFrame()
						end
						local itemLink = string.match(prefex, "|%x+|Hitem:.-|h.-|h|r")
						if itemLink ~= nil then
							local owner = string.match(prefex, "<PLH>%s* Nobody%s* rolled%s* for%s* |%x+|Hitem:.-|h.-|h|r%s* from%s* (.+)")
							if owner == self.player then
								self:winTablesShow(nil, itemLink, owner, nil)
								return false;
							end
						end
					end
				end
				-- ================================== END PLH ========================================--

				if self.group then
					-- trigered when you loot an item
					if (event == "CHAT_MSG_LOOT") then
						if self.lootMethod ~= "master" then
							if name == self.player then
								local iLink = string.match(prefex, ".*(|%x+|Hitem:.-|h.-|h|r).*")
								local ItemQuality = select(3, GetItemInfo(iLink))
								if ItemQuality == 4 then
									-- epic quality items only
									self:tradeTablesShow(iLink)
								end
							end
						end
					elseif (event == "CHAT_MSG_ADDON") then
						if (prefex == self.prefix) then
							local i, j
							if message == "<LH>ReRoll" then
								RandomRoll(1, 100)
								return
							end
							i, j = string.find(message, "<LH><PLH>|%x+|Hitem:.-|h.-|h|r")
							if i ~= nil and j ~= nil then
								local iLink = string.match(message, "<LH><PLH>(|%x+|Hitem:.-|h.-|h|r)")
								SendChatMessage("TRADE " .. iLink, "WHISPER", nil, name)
								return
							end
							i, j = string.find(message, "<LH>%s* Roll%s* for%s* |%x+|Hitem:.-|h.-|h|r%s* from%s* .+")
							if i ~= nil and j ~= nil then
								local owner = string.match(message, "<LH>%s* Roll%s* for%s* |%x+|Hitem:.-|h.-|h|r%s* from%s* (.+)")
								if owner ~= self.player then
									local itemLink = string.match(message, "|%x+|Hitem:.-|h.-|h|r")
									self.itemLink = itemLink
									self.owner = owner
									self.roolFrame:ShowFrame(owner, itemLink)
									return
								end
							end
							i, j = string.find(message, "<LH>%s* .+%s* won%s* |%x+|Hitem:.-|h.-|h|r%s* from%s* .+%s* with%s* a%s* %d*")
							if i ~= nil and j ~= nil then
								if self.roolFrame ~= nil then
									self.roolFrame:HideFrame()
								end
								local itemLink = string.match(message, "|%x+|Hitem:.-|h.-|h|r")
								if itemLink ~= nil then
									local winer = string.match(message, "<LH>%s* (.+)%s* won%s* |%x+|Hitem:.-|h.-|h|r%s* from%s* .+%s* with%s* a%s* %d*")
									local owner = string.match(message, "<LH>%s* .+%s* won%s* |%x+|Hitem:.-|h.-|h|r%s* from%s* (.+)%s* with%s* a%s* %d*")
									local rolled = string.match(message, "<LH>%s* .+%s* won%s* |%x+|Hitem:.-|h.-|h|r%s* from%s* .+%s* with%s* a%s* (%d*)")
									if winer == self.player or owner == self.player then
										self:winTablesShow(winer, itemLink, owner, rolled)
										return
									end
								end
							end
							i, j = string.find(message, "<LH>%s* Nobody%s* rolled%s* for%s* |%x+|Hitem:.-|h.-|h|r%s* from%s* .+")
							if i ~= nil and i ~= nil then
								if self.roolFrame ~= nil then
									self.roolFrame:HideFrame()
								end
								local itemLink = string.match(message, "|%x+|Hitem:.-|h.-|h|r")
								if itemLink ~= nil then
									local owner = string.match(message, "<LH>%s* Nobody%s* rolled%s* for%s* |%x+|Hitem:.-|h.-|h|r%s* from%s* (.+)")
									if owner == self.player then
										self:winTablesShow(nil, itemLink, owner, nil)
										return
									end
								end
							end
						end
					end
					-- functions Involving Group Leader only
					if (self.leader and self.lootMethod ~= "master") or(self.lootMethod == "master" and self.masterLooter) then
						-- all functions involving GROUP LEADER -----------------------------------------------
						if event == "CHAT_MSG_ADDON" then
							i, j = string.find(message, "<LH>Trade%s* |%x+|Hitem:.-|h.-|h|r")
							if i ~= nil and j ~= nil then
								local iLink = string.match(message, ".*(|%x+|Hitem:.-|h.-|h|r).*")
								if iLink ~= nil then
									if IsAddOnLoaded("PersonalLootHelper") and self.leader and self.lootMethod ~= "master" and IsInInstance() then
										SendAddonMessage(self.prefix, "<LH><PLH>" .. iLink, "WHISPER", name)
										-- redirect rool to <PLH>
										return
									else
										-- items added to the queue --
										table.insert(self.itemQueue, { iLink, name })
										-- insert {itemLink,OwnerOftheItem}
										table.sort(self.itemQueue, function(a, b) return select(4, GetItemInfo(a[1])) < select(4, GetItemInfo(b[1])) end);
										-- sort the list so higher i-lvl items are rolled for first
										return
									end
								end
							end
							-- lets group leader know who passed on the item
							if self.size > 0 then
								if message == "<LH>Roll M" then
									self.rollType[name] = "M"
									return
								elseif message == "<LH>Roll O" then
									self.rollType[name] = "O"
									return
								elseif message == "<LH>Roll U" then
									self.rollType[name] = "U"
									return
								elseif message == "<LH>Roll T" then
									self.rollType[name] = "T"
									return
								elseif message == "<LH>Roll P" then
									self.rollType[name] = "P"
									self.rolls[name] = -1
									self.size = self.size + 1
									return
								end
							end
						elseif (event == "CHAT_MSG_SYSTEM") then
							if self.size > 0 then
								local i, j = string.find(prefex, ".+%s*rolls%s*%d+%s*.+")
								if i ~= nil and j ~= nil then
									if self.rolling == nil then
										self.rolling = GetNumGroupMembers()
									end
									local results = { string.match(prefex, "([^%s]+)%s*rolls%s*(%d+)%s*(.+)") }
									local minmax = { string.match(results[3], "(%d+)-(%d+)") }
									if minmax[1] == "1" and minmax[2] == "100" then
										if (self.rolls[results[1]] == nil or self.rolls[results[1]] == -1) and(self.owner ~= results[1]) then
											if self.candidates[results[1]] ~= nil or tonumber(self.owner) == nil then
												if self.reroll == true then
													for _, winner in pairs(self.winners) do
														if results[1] == winner then
															self.rolls[results[1]] = results[2];
															self.size = self.size + 1
														end
													end
												else
													self.rolls[results[1]] = results[2];
													self.size = self.size + 1
												end
											else
												SendChatMessage(results[1] .. " roll will not count !!! (not elegible for this loot)", self.chatType)
											end
										else
											SendChatMessage(results[2] .. "  will not count!!! Your current roll is: " .. self.rolls[results[1]], "WHISPER", nil, results[1])
										end
									end
								end
							end
						elseif event == "CHAT_MSG_WHISPER" then
							local i, j = string.find(string.lower(prefex), string.lower("%s*|%x+|Hitem:.-|h.-|h|r%s*|%x+|Hitem:.-|h.-|h|r%s*"))
							if i ~= nil and j ~= nil then
								local iLink, iLink1 = string.match(prefex, "%s*(|%x+|Hitem:.-|h.-|h|r)%s*(|%x+|Hitem:.-|h.-|h|r)%s*")
								if iLink ~= nil and iLink1 ~= nil then
									if iLink == iLink1 then
										if IsAddOnLoaded("PersonalLootHelper") and self.leader and self.lootMethod ~= "master" and IsInInstance() then
											SendAddonMessage(self.prefix, "<LH><PLH>" .. iLink, "WHISPER", name)
											-- redirect rool to <PLH>
											return
										else
											-- items added to the queue --
											table.insert(self.itemQueue, { iLink, name })
											-- insert {itemLink,OwnerOftheItem}
											table.sort(self.itemQueue, function(a, b) return select(4, GetItemInfo(a[1])) < select(4, GetItemInfo(b[1])) end)
											return
										end
									end
								end
							end
							if (not IsAddOnLoaded("PersonalLootHelper")) and self.leader or self.lootMethod == "master" then
								i, j = string.find(string.lower(prefex), string.lower("%s*trade%s*|%x+|Hitem:.-|h.-|h|r%s*"))
								if i ~= nil and j ~= nil then
									local iLink = string.match(prefex, "|%x+|Hitem:.-|h.-|h|r")
									table.insert(self.itemQueue, { iLink, name })
									table.sort(self.itemQueue, function(a, b) return select(4, GetItemInfo(a[1])) < select(4, GetItemInfo(b[1])) end);
									return
								end
							end
						end


						if (self.lootMethod == "master" and self.masterLooter) then
							if event == "LOOT_OPENED" then
								if mainFrame.debug then

								end
								if GetNumLootItems() > 0 then
									self.candidates = { }
									self.masterLootQueue = { }
									self.awardLoot = true
									for lootNum = 1, GetNumLootItems() do
										local link = GetLootSlotLink(lootNum)
										if link ~= nil then
											local ItemQuality = select(3, GetItemInfo(link))
											if ItemQuality >= self.lootThreshold then
												table.insert(self.masterLootQueue, { link, lootNum })
											end
										end
									end
									self.automateBTN:Show()
								end
							elseif event == "LOOT_CLOSED" then
								for k, l in pairs(self.masterLootQueue) do
									for i, j in pairs(self.itemQueue) do
										if j[2] == l[2] then
											table.remove(self.itemQueue, i)
										end
									end
								end
								self.masterLootQueue = { }
								self.awardLoot = false
								self.automateBTN:Hide()
								self.nextBTN:Hide()
							elseif event == "LOOT_SLOT_CLEARED" then
								local num = tonumber(prefex)
								for i, tuple in pairs(self.masterLootQueue) do
									if tuple[2] == num then
										table.remove(self.masterLootQueue, i)
										return
									end
								end
							end
						end
					end
				end
			end
		end
		)
		return mainFrame
	end
}

