timer = {
    Create = function(self, width, height, name, attachTo, alpha, seconds)
        frame = CreateFrame("Frame", name, UIParent)
        frame.width = width
        frame.height = height
        frame.name = name
        frame.attachedTo = attachTo
		frame:SetParent(attachTo)
        frame.seconds = seconds
        frame.timerAlpha = alpha
        if (attachTo == nil) then
            frame:SetPoint("CENTER")
        else
            frame:SetPoint("BOTTOMLEFT", attachTo, "BOTTOMLEFT", 5, -1*(frame.height)-2)
			frame:SetPoint("BOTTOMRIGHT", attachTo, "BOTTOMRIGHT", -5, -1*(frame.height)-2)
            frame.width = frame.attachedTo:GetWidth()-10
        end
        frame:SetSize(frame.width, frame.height)
        frame.interval = frame:GetWidth() / frame.seconds
        
        local texture = frame:CreateTexture()
        texture:SetAllPoints()
        texture:SetColorTexture(1, 1, 1, 0.2)
        frame:SetFrameStrata("HIGH")
        
        frame.background = texture
        
        
        local timer = CreateFrame("Slider", "timeSlider", frame)
        timer.time = 0
        timer.active = false
        timer.attachedTo = frame.attachedTo
        timer.alpha = frame.timerAlpha
        timer.seconds = frame.seconds
        timer:SetWidth(frame:GetWidth() -2)
        timer.interval = timer:GetWidth() / timer.seconds
        timer:ClearAllPoints()
        timer:SetHeight(frame:GetHeight() -2)
        timer:SetPoint("LEFT", 1, 0)
        
        local timerbg = timer:CreateTexture(nil, "BACKGROUND")
        timerbg:SetAllPoints()
        timerbg:SetColorTexture(0, 0, 0, timer.alpha)
        timer.background = timerbg
        
        timer.changeTexture = function(self)
            -- red 1,0,0    yellow 1,1,0   green 0,1,0    1/self.seconds
            local helf = self.seconds / 2
            if self.timerValue > helf then
                self.background:SetColorTexture(1 / helf *(self.seconds - self.timerValue), 1, 0, self.alpha)
            else
                self.background:SetColorTexture(1,(self.timerValue / helf), 0, self.alpha)
            end
        end
        
        local timeText = timer:CreateFontString()
        timeText:SetSize(frame:GetWidth(), frame:GetHeight())
        timeText:SetTextColor(0, 0, 0, 1)
        timeText:SetPoint("TOPLEFT", frame, "TOPLEFT", 0, 0)
        timeText:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", 0, 0)
        
        
        timeText:SetDrawLayer("OVERLAY")
        timeText.font = "Fonts\\ARIALN.TTF"
        timeText:SetFont(timeText.font, frame:GetHeight(), "")
        timeText:SetText(tostring(timer.seconds))
        
        timeText.SetValues = function(self, width, height)
            self:SetSize(width, height)
            if width < height then
                self:SetFont(self.font, width, "")
            else
                self:SetFont(self.font, height, "")
            end
        end
        
        
        timer.text = timeText
        
        
        timer:SetScript("OnUpdate",
            function(self, e, ...)
                if self.active then
                    self.time = self.time + e
                    self.timerValue = timer.seconds - math.floor(self.time)
                    self:SetWidth(self.timerValue * self.interval)
                    self:changeTexture()
                    self.text:SetText(tostring(self.timerValue))
                    if (self.seconds - self.time) < 0 then
                        self.active = false
                        self.time = 0
                        self:SetWidth(timer.seconds * self.interval)
                        self:GetParent():Hide()
                        self.attachedTo:Hide()
                    end
                end
            end
        )
        
        timer.SetValues = function(self, width, height, seconds, interval)
            self:SetWidth(width)
            self:SetHeight(height)
            self.seconds = seconds
            self.interval = interval
            self.text:SetValues(width, height)
        end
        
        frame.timer = timer;
        
		frame.ShowFrame = function(self)
                self:SetWidth(self.attachedTo:GetWidth())
                self.interval = frame:GetWidth() / frame.seconds
                self.timer:SetValues(self:GetWidth() -2, self:GetHeight() -2, self.seconds, self.interval)
                self.timer.text:SetSize(self:GetWidth(), self:GetHeight())
				self.time = 0
                self.timer.active = true
				self:Show()
        end
        
		frame.HideFrame = function(self)
			self.timer.active = false
			self.timer.time = 0
			self.timer:SetWidth(frame.timer.seconds * frame.timer.interval)
			self:Hide()
		end


        frame:HideFrame()
		return frame
    end
}
